#! /bin/bash
#
# install script fuer schukodaemon am Server
# 1.5.2017
#
##################################################################

lmn7=$(dpkg -s linuxmuster-base7 2>&1 | grep Status)

if [[ $lmn7 =~ 'install ok' ]]
then
   mausskpfad="/srv/samba/schools/default-school/program/maus_sk/"
   etcpfad="/etc/linuxmuster/maus/"
   sbinpfad="/usr/sbin/"
   initpfad="/etc/init.d/"
else
   mausskpfad="/home/samba/progs/maus_sk/"
   etcpfad="/etc/linuxmuster/maus/"
   sbinpfad="/usr/sbin/"
   initpfad="/etc/init.d/"
fi

##################################################################

if [ "$(id -u)" != "0" ]; then
   echo "###################################"
   echo "# This script must be run as root #"
   echo "###################################"
   exit 1
fi

echo "### Installation schukodaemon startet ###"

mkdir -p $etcpfad

if [ -e "$etcpfad"schukodaemon.cfg ]; then
   echo "############################################################################"
   echo "# ACHTUNG!                                                                 #"
   echo "# Die Konfigurationsdatei schukodaemon.cfg ex. schon, sie wird beibehalten.#"
   echo "# Eine neue Konfigurationsdatei liegt nun unter schukodaemon.cfg.neu.      #"
   echo "# Ggf. die bisherige Konfigurationsdatei entsprechend anpassen.            #"
   echo "############################################################################"
   cp schukodaemon.cfg "$etcpfad"schukodaemon.cfg.neu
   chmod 640 "$etcpfad"schukodaemon.cfg.neu
else
   cp schukodaemon.cfg $etcpfad
   chmod 640 "$etcpfad"schukodaemon.cfg
fi

echo "Prozesse schukodaemon stop ..."
killall -e -9 schukodaemon
sleep 2

openssl genrsa -out "$etcpfad"sk.key 2048
openssl req -x509 -new -nodes -subj "/C=DE/ST=BW/L=Schule/O=schukodaemon/CN=schukodaemon" -extensions v3_ca -key "$etcpfad"sk.key -days 3650 -out "$etcpfad"sk.cert -sha512

echo "Firewall wird konfiguriert ..."

if [[ $lmn7 =~ 'install ok' ]]; then
   echo "firewall ????????????????????????????????????????"
else
   sed -i '/[^0-9]9731/ !s/^tcp .*/&,9731/' /etc/linuxmuster/allowed_ports
   sed -i '/[^0-9]9732/ !s/^tcp .*/&,9732/' /etc/linuxmuster/allowed_ports
   restart-fw --int
fi

cp schukodaemon $sbinpfad
cp schukodaemon.sh $initpfad

chown root:root "$sbinpfad"schukodaemon "$initpfad"schukodaemon.sh
chmod 755 "$sbinpfad"schukodaemon "$initpfad"schukodaemon.sh

echo "Boot-Script wird aktiviert ..."

/usr/sbin/update-rc.d schukodaemon.sh defaults

"$initpfad"schukodaemon.sh start

echo "### Installation schukodaemon beendet ###"

exit 0
